#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

int main()
{
    char *p_array[0xFF];
    int i;
    for (i = 0; i < 0xFF; i++)
    {
        p_array[i] = NULL;
        p_array[i] = malloc(1024 * 1024);
        if (p_array[i] == NULL)
        {
            printf("out of memory\n");
            return -1;
        }
        memset(p_array[i], i, 1024 * 1024);
        usleep(100000);
    }
    printf("malloc ok\n");
    printf("start checking data\n");
    for (i = 0; i < 0xFF; i++)
    {
        int j;
        char *p = p_array[i];
        for (j = 0; j < 1024 * 1024; j++)
        {
            if (*p != i)
            {
                printf("read data error\n");
                return -1;  
            }
            p++;
        }
    }
    printf("read data ok\n");
    for (i = 0; i < 0xFF; i++)
    {
        free(p_array[i]);
    }
    printf("free memory ok\n");
    return 0;
}
